<?php
/**
 * @copyright: Copyright © 2020 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */

namespace Firebear\PlatformSap\Model\Customer;

/**
 * Class UpdateConsumer
 * @package Firebear\PlatformSap\Model\Customer
 */
class UpdateConsumer
{
    /**
     * @var \Firebear\PlatformSap\Model\Export\Adapter\Gateway\Customer
     */
    private $gateway;

    /**
     * UpdateConsumer constructor.
     * @param \Firebear\PlatformSap\Model\Export\Adapter\Gateway\Customer $gateway
     */
    public function __construct(
        \Firebear\PlatformSap\Model\Export\Adapter\Gateway\Customer $gateway
    ) {
        $this->gateway = $gateway;
    }

    /**
     * @param \Magento\Customer\Api\Data\CustomerInterface $customer
     */
    public function processMessage(\Magento\Customer\Api\Data\CustomerInterface $customer)
    {
        $this->gateway->addCustomer($customer);
    }
}
