<?php
/**
 * @copyright: Copyright © 2021 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */
namespace Firebear\PlatformSap\Model\Import;

use Firebear\ImportExport\Model\Import\CatalogRule as CatalogRuleBase;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Framework\Serialize\Serializer\Json as Serializer;
use Magento\CatalogRule\Model\RuleFactory;
use Magento\CatalogRule\Model\Rule\Action\SimpleActionOptionsProvider;
use Magento\ImportExport\Model\ImportFactory;
use Magento\Rule\Model\ConditionFactory;
use Firebear\ImportExport\Helper\Data as ImportExportHelper;
use Firebear\ImportExport\Model\Import\Context;

/**
 * CatalogRule import
 */
class CatalogRule extends CatalogRuleBase
{
    /**
     * Field list
     *
     * @var array
     */
    protected $fields = [
        self::COLUMN_RULE_ID,
        'name',
        'description',
        'website_ids',
        'customer_group_ids',
        'from_date',
        'to_date',
        'stop_rules_processing',
        'simple_action',
        'discount_amount',
        'sort_order',
        'is_active',
        'sap_id'
    ];


    /**
     * @var ImportExportHelper
     */
    protected $_helper;

    /**
     * CatalogRule constructor.
     * @param Context $context
     * @param ScopeConfigInterface $scopeConfig
     * @param ImportFactory $importFactory
     * @param RuleFactory $ruleFactory
     * @param ConditionFactory $conditionFactory
     * @param Serializer $serializer
     * @param SimpleActionOptionsProvider $simpleActionProvider
     * @param ImportExportHelper $helper
     * @param array $data
     */
    public function __construct(
        Context $context,
        ScopeConfigInterface $scopeConfig,
        ImportFactory $importFactory,
        RuleFactory $ruleFactory,
        ConditionFactory $conditionFactory,
        Serializer $serializer,
        SimpleActionOptionsProvider $simpleActionProvider,
        ImportExportHelper $helper,
        array $data = []
    ) {
        $this->_helper = $helper;
        parent::__construct(
            $context,
            $scopeConfig,
            $importFactory,
            $ruleFactory,
            $conditionFactory,
            $serializer,
            $simpleActionProvider,
            $data
        );
    }
}
