<?php
/**
 * @copyright: Copyright © 2020 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */
namespace Firebear\PlatformSap\Model\Order;

/**
 * Class UpdatePublisher
 * @package Firebear\PlatformSap\Model\Order
 */
class UpdatePublisher
{
    const TOPIC_NAME = 'sap.order.update';

    /**
     * @var \Magento\Framework\MessageQueue\PublisherInterface
     */
    private $publisher;

    /**
     * @param \Magento\Framework\MessageQueue\PublisherInterface $publisher
     */
    public function __construct(\Magento\Framework\MessageQueue\PublisherInterface $publisher)
    {
        $this->publisher = $publisher;
    }

    /**
     * {@inheritdoc}
     */
    public function execute($orderId)
    {
        $this->publisher->publish(self::TOPIC_NAME, $orderId);
    }
}
