<?php
/**
 * @copyright: Copyright © 2021 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */

namespace Firebear\PlatformSap\Setup;

use Magento\Framework\MessageQueue\PoisonPill\PoisonPillPutInterface;
use Magento\Framework\Setup\InstallSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;

/**
 * Class Recurring
 * @package Firebear\PlatformSap\Setup
 */
class Recurring implements InstallSchemaInterface
{
    /**
     * @var PoisonPillPutInterface
     */
    private $poisonPillPut;

    /**
     * Recurring constructor.
     * @param PoisonPillPutInterface $poisonPillPut
     */
    public function __construct(PoisonPillPutInterface $poisonPillPut)
    {
        $this->poisonPillPut = $poisonPillPut;
    }

    /**
     * @param SchemaSetupInterface $setup
     * @param ModuleContextInterface $context
     * @throws \Exception
     */
    public function install(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $this->poisonPillPut->put();
    }
}